package com.fr.plugin.db.redis;

import com.fr.base.TableData;
import com.fr.design.data.tabledata.tabledatapane.AbstractTableDataPane;
import com.fr.design.fun.ServerTableDataDefineProvider;
import com.fr.design.fun.impl.AbstractTableDataDefineProvider;
import com.fr.locale.InterProviderFactory;
import com.fr.plugin.db.redis.core.RedisScriptTableData;
import com.fr.plugin.db.redis.ui.RedisScriptTableDataPane;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-03-18
 */
public class RedisScriptTableDataDefine extends AbstractTableDataDefineProvider implements ServerTableDataDefineProvider {

    @Override
    public int currentAPILevel() {
        return CURRENT_LEVEL;
    }

    @Override
    public Class<? extends TableData> classForTableData() {
        return RedisScriptTableData.class;
    }

    @Override
    public Class<? extends TableData> classForInitTableData() {
        return RedisScriptTableData.class;
    }

    @Override
    public Class<? extends AbstractTableDataPane> appearanceForTableData() {
        return RedisScriptTableDataPane.class;
    }

    @Override
    public String nameForTableData() {
        return InterProviderFactory.getProvider().getLocText("Plugin-Redis_Script_Table_Data");
    }

    @Override
    public String prefixForTableData() {
        return "redis";
    }

    @Override
    public String iconPathForTableData() {
        return "/com/fr/plugin/db/redis/images/redis.png";
    }
}
