package com.fr.plugin.db.redis.core.emb.impl;

import com.fr.plugin.db.redis.core.emb.Redis;
import com.fr.ssh.jsch.Session;
import com.fr.third.redis.clients.jedis.Jedis;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-03-21
 */
public class ProxyRedis implements Redis {

    private Session session;
    private Jedis jedis;

    public ProxyRedis(Session session, Jedis jedis) {
        this.session = session;
        this.jedis = jedis;
    }

    @Override
    public Jedis getClient() {
        return jedis;
    }

    @Override
    public void close() {
        jedis.close();
        session.disconnect();
    }
}
