package com.fr.plugin.db.redis.core.order;

import com.fr.base.Parameter;
import com.fr.config.utils.UniqueKey;
import com.fr.general.GeneralUtils;
import com.fr.script.Calculator;
import com.fr.stable.ParameterProvider;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLable;
import com.fr.stable.xml.XMLableReader;

public abstract class OrderValue extends UniqueKey implements XMLable {

    private static final long serialVersionUID = -5421898153556627638L;

    public static final String XML_TAG = "OrderValue";

    public abstract Object getValue();

    public abstract int toIndex(Calculator cal, Parameter[] ps);

    public ParameterProvider[] analyze4Parameters() {
        return new ParameterProvider[0];
    }

    @Override
    public void readXML(XMLableReader reader) {
        if (reader.isChildNode()) {
            String tagName = reader.getTagName();
            if ("Attr".equals(tagName)) {
                readValue(reader);
            }
        }
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        writer.startTAG("Attr");
        writer.attr("value", GeneralUtils.objectToString(getValue()));
        writer.end();
    }

    public abstract void readValue(XMLableReader reader);

    @Override
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
