package com.fr.plugin.db.redis.core.visit.impl;

import com.fr.base.Parameter;
import com.fr.plugin.db.redis.core.visit.AbstractVisitor;
import com.fr.script.Calculator;
import com.fr.third.redis.clients.jedis.Jedis;

import java.util.ArrayList;
import java.util.List;

public class HashGetVisitor extends AbstractVisitor <String>{
    @Override
    public List<List<String>> getContent(Calculator calculator, Parameter[] ps, Jedis client, String query, int rowCount) throws Exception {
        String[] arr = query.trim().split(TOKEN_SPACE);
        if (arr.length < 3) {
            throw new IllegalArgumentException("Illegal query:" + query);
        }
        String data = client.hget(trimCommand(arr[1]), trimCommand(arr[2]));
        List<String> column = new ArrayList<String>();
        column.add(data);

        List<List<String>> result = new ArrayList<List<String>>();
        result.add(column);
        result.add(column);
        return result;
    }

    @Override
    public String keyWord() {
        return "hget";
    }
}
