package com.fr.plugin.db.redis.help;

import com.fr.plugin.db.redis.core.emb.Redis;
import com.fr.plugin.db.redis.help.client.SimpleDataModel;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-08-26
 */
public interface RedisClient<A, O> {

    SimpleDataModel build(Redis redis, String query, int limit);

    @ScriptBridge
    String get(String key);

    @ScriptBridge
    String hget(String key, String field);

    @ScriptBridge
    A hkeys(String key);

    @ScriptBridge
    A hmget(String key, String... fields);

    @ScriptBridge
    O hgetAll(String key);

    @ScriptBridge
    A keys(String pattern);

    @ScriptBridge
    A lrange(String key, long start, long end);

    @ScriptBridge
    A mget(A keys);

    @ScriptBridge
    A smembers(String key);
}
