package com.fr.plugin.db.redis.util;

import com.eclipsesource.v8.V8Object;
import com.fr.base.Parameter;
import com.fr.base.TemplateUtils;
import com.fr.plugin.db.redis.help.ScriptBridge;
import com.fr.stable.ArrayUtils;
import com.fr.third.redis.clients.jedis.Jedis;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-03-18
 */
public class RedisUtils {

    /**
     * 关闭redis客户端
     * @param jedis redis客户端对象
     */
    public static void close(Jedis jedis) {
        jedis.close();
    }

    public static String calculateQuery(String query, Parameter[] ps) {
        if (ArrayUtils.isEmpty(ps)) {
            return query;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        for (Parameter p : ps) {
            map.put(p.getName(), p.getValue());
        }
        try {
            return TemplateUtils.renderParameter4Tpl(query, map);
        } catch (Exception e) {
            return query;
        }
    }

    public static void registerJavaMethods(V8Object v8Object, Object target) {
        Method[] methods = target.getClass().getMethods();
        for (Method m : methods) {
            if (m.getAnnotation(ScriptBridge.class) != null) {
                v8Object.registerJavaMethod(target, m.getName(), m.getName(), m.getParameterTypes());
            }
        }
    }
}
